## org.biojava.bio.program.sax
Class SequenceAlignmentSAXParser

    java.lang.Object
      org.biojava.bio.program.sax.SequenceAlignmentSAXParser

All Implemented Interfaces:
  org.xml.sax.XMLReader

    public class SequenceAlignmentSAXParser

extends java.lang.Object

A SAX2 parser for dealing with a sequence alignments. The format of any given alignment is automatically detected (e.g. ClustalW, Needle). Supported alignment formats are:

- ClustalW
- Needle

Copyright © 2000-2002 Cambridge Antibody Technology. All Rights Reserved.

Primary author -

- Simon Brocklehurst (CAT)

Other authors -

- Neil Benn (CAT)
- Lawrence Bower (CAT)
- Derek Crockford (CAT)
- Tim Dilks (CAT)
- Colin Hardman (CAT)
- Stuart Johnston (CAT)

Version:
  1.0
Author:
  Cambridge Antibody Technology (CAT)

Field Summary
`protected int` `iState`
`protected java.lang.String` `oFullNamespacePrefix`
`protected org.xml.sax.ContentHandler` `oHandler`
`protected java.lang.String` `oNamespacePrefix`
`protected boolean` `tNamespacePrefixes`
`protected boolean` `tNamespaces`

Constructor Summary
`SequenceAlignmentSAXParser()` Initialises internal state Sets namespace prefix to "biojava"

Method Summary
`void` `addPrefixMapping(java.lang.String poPrefix, java.lang.String poURI)` Adds a namespace prefix to URI mapping as (key,value) pairs.
`protected void` `changeState(int piState)` Centralise chaining of iState field to help with debugging.
`protected void` `characters(char[] ch, int start, int length)` Utility method to centralize the sending of a SAX characters message a document handler.
`protected void` `endElement(org.biojava.bio.program.sax.QName poQName)` Utility method to centralize the sending of a SAX endElement message a document handler.
`org.xml.sax.ContentHandler` `getContentHandler()` Return the content handler.
`protected java.io.BufferedReader` `getContentStream(org.xml.sax.InputSource poSource)` Create a stream from an an InputSource, picking the correct stream according to order of precedance.
`org.xml.sax.DTDHandler` `getDTDHandler()` Do-nothing implementation of interface method
`org.xml.sax.EntityResolver` `getEntityResolver()` Do-nothing implementation of interface method
`org.xml.sax.ErrorHandler` `getErrorHandler()` Do-nothing implementation of interface method
`boolean` `getFeature(java.lang.String poName)` Do-nothing implementation of interface method
`java.lang.String` `getNamespacePrefix()` Describe `getNamespacePrefix` method here.
`boolean` `getNamespacePrefixes()` Support SAX2 configuration of namespace support of parser.
`boolean` `getNamespaces()` Support SAX2 configuration of namespace support of parser.
`java.lang.Object` `getProperty(java.lang.String name)` Do-nothing implementation of interface method
`java.lang.String` `getURIFromPrefix(java.lang.String poPrefix)` Gets the URI for a namespace prefix, given that prefix, or null if the prefix is not recognised.
`void` `parse(org.xml.sax.InputSource poSource)` Describe 'parse' method here.
`void` `parse(java.lang.String poSystemId)` Full implementation of interface method.
`java.lang.String` `prefix(java.lang.String poElementName)` Given an unprefixed element name, returns a new element name with a namespace prefix
`void` `setContentHandler(org.xml.sax.ContentHandler poHandler)` Allow an application to register a content event handler.
`void` `setDTDHandler(org.xml.sax.DTDHandler handler)` Do-nothing implementation of interface method
`void` `setEntityResolver(org.xml.sax.EntityResolver resolver)` Do-nothing implementation of interface method
`void` `setErrorHandler(org.xml.sax.ErrorHandler handler)` Do-nothing implementation of interface method
`void` `setFeature(java.lang.String poName, boolean value)` Handles support for ReasoningDomain and Namespace-prefixes
`void` `setNamespacePrefix(java.lang.String poPrefix)`
`void` `setProperty(java.lang.String name, java.lang.Object value)` Do-nothing implementation of interface method
`protected void` `startElement(org.biojava.bio.program.sax.QName poQName, org.xml.sax.Attributes atts)` Utility method to centralize sending of a SAX startElement message to document handler

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### oHandler

    protected org.xml.sax.ContentHandler oHandler

### tNamespaces

    protected boolean tNamespaces

### tNamespacePrefixes

    protected boolean tNamespacePrefixes

### oNamespacePrefix

    protected java.lang.String oNamespacePrefix

### oFullNamespacePrefix

    protected java.lang.String oFullNamespacePrefix

### iState

    protected int iState

Constructor Detail

### SequenceAlignmentSAXParser

    public SequenceAlignmentSAXParser()

  Initialises internal state Sets namespace prefix to "biojava"

Method Detail

### parse

    public void parse(org.xml.sax.InputSource poSource)
               throws java.io.IOException,
                      org.xml.sax.SAXException

  Describe 'parse' method here.

  Specified by:
    `parse` in interface `org.xml.sax.XMLReader`
  Parameters:
    `poSource` - -
  Throws:
    `java.io.IOException`
    `org.xml.sax.SAXException`

### setContentHandler

    public void setContentHandler(org.xml.sax.ContentHandler poHandler)

  Allow an application to register a content event handler. If the application does not register a content handler, all content events reported by the SAX parser will be silently ignored.

  Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

  Specified by:
    `setContentHandler` in interface `org.xml.sax.XMLReader`
  Parameters:
    `poHandler` - a `ContentHandler` The XML content handler
  Throws:
    `java.lang.NullPointerException` - If the handler argument is null

### getContentHandler

    public org.xml.sax.ContentHandler getContentHandler()

  Return the content handler.

  Specified by:
    `getContentHandler` in interface `org.xml.sax.XMLReader`
  Returns:
    a `ContentHandler` The current content handler, or null if none has been registered.

### parse

    public void parse(java.lang.String poSystemId)
               throws java.io.IOException,
                      org.xml.sax.SAXException

  Full implementation of interface method.

  Specified by:
    `parse` in interface `org.xml.sax.XMLReader`
  Throws:
    `java.io.IOException`
    `org.xml.sax.SAXException`

### getFeature

    public boolean getFeature(java.lang.String poName)
                       throws org.xml.sax.SAXNotRecognizedException,
                              org.xml.sax.SAXNotSupportedException

  Do-nothing implementation of interface method

  Specified by:
    `getFeature` in interface `org.xml.sax.XMLReader`
  Throws:
    `org.xml.sax.SAXNotRecognizedException`
    `org.xml.sax.SAXNotSupportedException`

### setFeature

    public void setFeature(java.lang.String poName,
                           boolean value)
                    throws org.xml.sax.SAXNotRecognizedException,
                           org.xml.sax.SAXNotSupportedException

  Handles support for ReasoningDomain and Namespace-prefixes

  Specified by:
    `setFeature` in interface `org.xml.sax.XMLReader`
  Throws:
    `org.xml.sax.SAXNotRecognizedException`
    `org.xml.sax.SAXNotSupportedException`

### getProperty

    public java.lang.Object getProperty(java.lang.String name)
                                 throws org.xml.sax.SAXNotRecognizedException,
                                        org.xml.sax.SAXNotSupportedException

  Do-nothing implementation of interface method

  Specified by:
    `getProperty` in interface `org.xml.sax.XMLReader`
  Throws:
    `org.xml.sax.SAXNotRecognizedException`
    `org.xml.sax.SAXNotSupportedException`

### setProperty

    public void setProperty(java.lang.String name,
                            java.lang.Object value)
                     throws org.xml.sax.SAXNotRecognizedException,
                            org.xml.sax.SAXNotSupportedException

  Do-nothing implementation of interface method

  Specified by:
    `setProperty` in interface `org.xml.sax.XMLReader`
  Throws:
    `org.xml.sax.SAXNotRecognizedException`
    `org.xml.sax.SAXNotSupportedException`

### setEntityResolver

    public void setEntityResolver(org.xml.sax.EntityResolver resolver)

  Do-nothing implementation of interface method

  Specified by:
    `setEntityResolver` in interface `org.xml.sax.XMLReader`

### getEntityResolver

    public org.xml.sax.EntityResolver getEntityResolver()

  Do-nothing implementation of interface method

  Specified by:
    `getEntityResolver` in interface `org.xml.sax.XMLReader`

### setDTDHandler

    public void setDTDHandler(org.xml.sax.DTDHandler handler)

  Do-nothing implementation of interface method

  Specified by:
    `setDTDHandler` in interface `org.xml.sax.XMLReader`

### getDTDHandler

    public org.xml.sax.DTDHandler getDTDHandler()

  Do-nothing implementation of interface method

  Specified by:
    `getDTDHandler` in interface `org.xml.sax.XMLReader`

### setErrorHandler

    public void setErrorHandler(org.xml.sax.ErrorHandler handler)

  Do-nothing implementation of interface method

  Specified by:
    `setErrorHandler` in interface `org.xml.sax.XMLReader`

### getErrorHandler

    public org.xml.sax.ErrorHandler getErrorHandler()

  Do-nothing implementation of interface method

  Specified by:
    `getErrorHandler` in interface `org.xml.sax.XMLReader`

### startElement

    protected void startElement(org.biojava.bio.program.sax.QName poQName,
                                org.xml.sax.Attributes atts)
                         throws org.xml.sax.SAXException

  Utility method to centralize sending of a SAX startElement message to document handler

  Parameters:
    `poQName` - a `QName` value
    `atts` - an `Attributes` value
  Throws:
    `org.xml.sax.SAXException` - if an error occurs

### endElement

    protected void endElement(org.biojava.bio.program.sax.QName poQName)
                       throws org.xml.sax.SAXException

  Utility method to centralize the sending of a SAX endElement message a document handler.

  Parameters:
    `poQName` - -
  Throws:
    `org.xml.sax.SAXException` - thrown if
    `thrown` - if

### characters

    protected void characters(char[] ch,
                              int start,
                              int length)
                       throws org.xml.sax.SAXException

  Utility method to centralize the sending of a SAX characters message a document handler.

  Parameters:
    `ch` - -
    `start` - -
    `length` - -
  Throws:
    `org.xml.sax.SAXException` - thrown if
    `thrown` - if

### getNamespaces

    public boolean getNamespaces()

  Support SAX2 configuration of namespace support of parser.

### getNamespacePrefixes

    public boolean getNamespacePrefixes()

  Support SAX2 configuration of namespace support of parser.

### addPrefixMapping

    public void addPrefixMapping(java.lang.String poPrefix,
                                 java.lang.String poURI)

  Adds a namespace prefix to URI mapping as (key,value) pairs. This mapping can be looked up later to get URIs on request using the getURIFromPrefix method.

  Parameters:
    `poPrefix` - a `String` representation of the namespace prefix
    `poURI` - a `String` representation of the URI for the namespace prefix.

### getURIFromPrefix

    public java.lang.String getURIFromPrefix(java.lang.String poPrefix)

  Gets the URI for a namespace prefix, given that prefix, or null if the prefix is not recognised.

  Parameters:
    `poPrefix` - a `String` The namespace prefix.

### setNamespacePrefix

    public void setNamespacePrefix(java.lang.String poPrefix)

  Parameters:
    `poPrefix` - a `String` value

### getNamespacePrefix

    public java.lang.String getNamespacePrefix()

  Describe `getNamespacePrefix` method here.

  Returns:
    a `String` value

### prefix

    public java.lang.String prefix(java.lang.String poElementName)

  Given an unprefixed element name, returns a new element name with a namespace prefix

  Returns:
    a `String` value

### getContentStream

    protected java.io.BufferedReader getContentStream(org.xml.sax.InputSource poSource)

  Create a stream from an an InputSource, picking the correct stream according to order of precedance.

  Parameters:
    `poSource` - an `InputSource` value
  Returns:
    a `BufferedReader` value

### changeState

    protected void changeState(int piState)

  Centralise chaining of iState field to help with debugging. E.g. printing out value etc. All changes to iState should be made through this method.

  Parameters:
    `piState` - an `int` value